Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/HiveExperiment.cs
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/HiveExperiment.cs	(revision 4343)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/HiveExperiment.cs	(revision 4368)
@@ -620,151 +541,66 @@
     #region Snapshots
 
-    private void UpdateSnapshot(ResponseObject<SerializedJob> response) {
-      JobItem jobItem = jobItems.Single(x => x.JobDto.Id == response.Obj.JobInfo.Id);
-      jobItem.LatestSnapshot = response;
-    }
-
-    public void RequestSnapshot(Guid jobId) {
-      Thread t = new Thread(() => {
-        IClientFacade clientFacade = null;
-        try {
-          clientFacade = CreateStreamedClientFacade();
-
-          ResponseObject<SerializedJob> response;
-          int retryCount = 0;
-
-          Response snapShotResponse = clientFacade.RequestSnapshot(jobId);
-          if (snapShotResponse.StatusMessage == ResponseStatus.RequestSnapshot_JobIsNotBeeingCalculated) {
-            // job already finished
-            Logger.Debug("HiveExperiment: Abort - GetLastResult(false)");
-            response = clientFacade.GetLastSerializedResult(jobId, false, false);
-            Logger.Debug("HiveExperiment: Abort - Server: " + response.StatusMessage);
-          } else {
-            // server sent snapshot request to client
-            // poll until snapshot is ready
-            do {
-              Thread.Sleep(snapshotPollingIntervalMs);
-              Logger.Debug("HiveExperiment: Abort - GetLastResult(true)");
-              response = clientFacade.GetLastSerializedResult(jobId, false, true);
-              Logger.Debug("HiveExperiment: Abort - Server: " + response.StatusMessage);
-              retryCount++;
-              // loop while
-              // 1. problem with communication with server
-              // 2. job result not yet ready
-            } while (
-              (retryCount < maxSnapshotRetries) && (
-              response.StatusMessage == ResponseStatus.GetLastSerializedResult_JobResultNotYetThere)
-              );
-          }
-          if (response.StatusMessage == ResponseStatus.Ok) {
-            LogMessage(jobId, "Snapshot polling successfull for job " + jobId);
-            UpdateSnapshot(response);
-          } else {
-            LogMessage(jobId, "Error: Polling of Snapshot failed for job " + jobId + ": " + response.StatusMessage);
-          }
-        }
-        catch (Exception e) {
-          LogMessage("RequestSnapshot Thread failed badly: " + e.Message);
-          Logger.Error("RequestSnapshot Thread failed badly: " + e.Message);
-        }
-        finally {
-          ServiceLocator.DisposeClientFacade(clientFacade);
-        }
-      });
-      t.Start();
-    }
-
-    void JobItem_SnapshotRequestedStateChanged(object sender, EventArgs e) {
-      JobItem jobItem = (JobItem)sender;
-      if (jobItem.SnapshotRequestedState == SnapshotRequestedState.Requested) {
-        RequestSnapshot(jobItem.JobDto.Id);
-      }
-    }
-
-    #endregion
-
-    #region Required Plugin Search
-    /// <summary>
-    /// Returns a list of plugins in which the type itself and all members 
-    /// of the type are declared. Objectgraph is searched recursively.
-    /// </summary>
-    private IEnumerable<IPluginDescription> GetDeclaringPlugins(Type type) {
-      HashSet<Type> types = new HashSet<Type>();
-      FindTypes(type, types, "HeuristicLab.");
-      return GetDeclaringPlugins(types);
-    }
-
-    /// <summary>
-    /// Returns the plugins (including dependencies) in which the given types are declared
-    /// </summary>
-    private IEnumerable<IPluginDescription> GetDeclaringPlugins(IEnumerable<Type> types) {
-      HashSet<IPluginDescription> plugins = new HashSet<IPluginDescription>();
-      foreach (Type t in types) {
-        FindDeclaringPlugins(ApplicationManager.Manager.GetDeclaringPlugin(t), plugins);
-      }
-      return plugins;
-    }
-
-    /// <summary>
-    /// Finds the dependencies of the given plugin and adds it to the plugins hashset.
-    /// Also searches the dependencies recursively.
-    /// </summary>
-    private void FindDeclaringPlugins(IPluginDescription plugin, HashSet<IPluginDescription> plugins) {
-      if (!plugins.Contains(plugin)) {
-        plugins.Add(plugin);
-        foreach (IPluginDescription dependency in plugin.Dependencies) {
-          FindDeclaringPlugins(dependency, plugins);
-        }
-      }
-    }
-
-    /// <summary>
-    /// Recursively finds all types used in type which are in a namespace which starts with namespaceStart
-    /// Be aware that search is not performed on attributes
-    /// </summary>
-    /// <param name="type">the type to be searched</param>
-    /// <param name="types">found types will be stored there, needed in order to avoid duplicates</param>
-    /// <param name="namespaceStart">only types from namespaces which start with this will be searched and added</param>
-    private void FindTypes(Type type, HashSet<Type> types, string namespaceStart) {
-      if (!types.Contains(type) && type.Namespace.StartsWith(namespaceStart)) {
-        types.Add(type);
-
-        // constructors
-        foreach (ConstructorInfo info in type.GetConstructors()) {
-          foreach (ParameterInfo paramInfo in info.GetParameters()) {
-            FindTypes(paramInfo.ParameterType, types, namespaceStart);
-          }
-        }
-
-        // interfaces
-        foreach (Type t in type.GetInterfaces()) {
-          FindTypes(t, types, namespaceStart);
-        }
-
-        // events
-        foreach (EventInfo info in type.GetEvents()) {
-          FindTypes(info.EventHandlerType, types, namespaceStart);
-          FindTypes(info.DeclaringType, types, namespaceStart);
-        }
-
-        // properties
-        foreach (PropertyInfo info in type.GetProperties()) {
-          FindTypes(info.PropertyType, types, namespaceStart);
-        }
-
-        // fields
-        foreach (FieldInfo info in type.GetFields()) {
-          FindTypes(info.FieldType, types, namespaceStart);
-        }
-
-        // methods
-        foreach (MethodInfo info in type.GetMethods()) {
-          foreach (ParameterInfo paramInfo in info.GetParameters()) {
-            FindTypes(paramInfo.ParameterType, types, namespaceStart);
-          }
-          FindTypes(info.ReturnType, types, namespaceStart);
-        }
-      }
-    }
+    //private void UpdateSnapshot(ResponseObject<SerializedJob> response) {
+    //  JobItem jobItem = jobItems.Single(x => x.JobDto.Id == response.Obj.JobInfo.Id);
+    //  jobItem.LatestSnapshot = response;
+    //}
+
+    //public void RequestSnapshot(Guid jobId) {
+    //  Thread t = new Thread(() => {
+    //    IClientFacade clientFacade = null;
+    //    try {
+    //      clientFacade = CreateStreamedClientFacade();
+
+    //      ResponseObject<SerializedJob> response;
+    //      int retryCount = 0;
+
+    //      Response snapShotResponse = clientFacade.RequestSnapshot(jobId);
+    //      if (snapShotResponse.StatusMessage == ResponseStatus.RequestSnapshot_JobIsNotBeeingCalculated) {
+    //        // job already finished
+    //        Logger.Debug("HiveExperiment: Abort - GetLastResult(false)");
+    //        response = clientFacade.GetLastSerializedResult(jobId, false, false);
+    //        Logger.Debug("HiveExperiment: Abort - Server: " + response.StatusMessage);
+    //      } else {
+    //        // server sent snapshot request to client
+    //        // poll until snapshot is ready
+    //        do {
+    //          Thread.Sleep(snapshotPollingIntervalMs);
+    //          Logger.Debug("HiveExperiment: Abort - GetLastResult(true)");
+    //          response = clientFacade.GetLastSerializedResult(jobId, false, true);
+    //          Logger.Debug("HiveExperiment: Abort - Server: " + response.StatusMessage);
+    //          retryCount++;
+    //          // loop while
+    //          // 1. problem with communication with server
+    //          // 2. job result not yet ready
+    //        } while (
+    //          (retryCount < maxSnapshotRetries) && (
+    //          response.StatusMessage == ResponseStatus.GetLastSerializedResult_JobResultNotYetThere)
+    //          );
+    //      }
+    //      if (response.StatusMessage == ResponseStatus.Ok) {
+    //        LogMessage(jobId, "Snapshot polling successfull for job " + jobId);
+    //        //UpdateSnapshot(response);
+    //      } else {
+    //        LogMessage(jobId, "Error: Polling of Snapshot failed for job " + jobId + ": " + response.StatusMessage);
+    //      }
+    //    }
+    //    catch (Exception e) {
+    //      LogMessage("RequestSnapshot Thread failed badly: " + e.Message);
+    //      Logger.Error("RequestSnapshot Thread failed badly: " + e.Message);
+    //    }
+    //    finally {
+    //      ServiceLocator.DisposeClientFacade(clientFacade);
+    //    }
+    //  });
+    //  t.Start();
+    //}
+
+    //void JobItem_SnapshotRequestedStateChanged(object sender, EventArgs e) {
+    //  JobItem jobItem = (JobItem)sender;
+    //  if (jobItem.SnapshotRequestedState == SnapshotRequestedState.Requested) {
+    //    RequestSnapshot(jobItem.JobDto.Id);
+    //  }
+    //}
+
     #endregion
 
@@ -827,4 +663,16 @@
       LogMessage("Experiment changed");
       EventHandler handler = ExperimentChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+
+    public event EventHandler RootJobChanged;
+    private void OnRootJobChanged() {
+      EventHandler handler = RootJobChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+
+    public event EventHandler RootJobItemChanged;
+    private void OnRootJobItemChanged() {
+      EventHandler handler = RootJobItemChanged;
       if (handler != null) handler(this, EventArgs.Empty);
     }
@@ -843,107 +691,13 @@
     }
 
-    private void RegisterJobItemListEvents() {
-      jobItems.CollectionReset += new CollectionItemsChangedEventHandler<IndexedItem<JobItem>>(jobItems_CollectionReset);
-      jobItems.ItemsAdded += new CollectionItemsChangedEventHandler<IndexedItem<JobItem>>(jobItems_ItemsAdded);
-      jobItems.ItemsRemoved += new CollectionItemsChangedEventHandler<IndexedItem<JobItem>>(jobItems_ItemsRemoved);
-      jobItems.ItemsReplaced += new CollectionItemsChangedEventHandler<IndexedItem<JobItem>>(jobItems_ItemsReplaced);
-      foreach (JobItem jobItem in jobItems) {
-        RegisterJobItemEvents(jobItem);
-      }
-    }
-
-    private void DeregisterJobItemListEvents() {
-      jobItems.CollectionReset -= new CollectionItemsChangedEventHandler<IndexedItem<JobItem>>(jobItems_CollectionReset);
-      jobItems.ItemsAdded -= new CollectionItemsChangedEventHandler<IndexedItem<JobItem>>(jobItems_ItemsAdded);
-      jobItems.ItemsRemoved -= new CollectionItemsChangedEventHandler<IndexedItem<JobItem>>(jobItems_ItemsRemoved);
-      jobItems.ItemsReplaced -= new CollectionItemsChangedEventHandler<IndexedItem<JobItem>>(jobItems_ItemsReplaced);
-      foreach (JobItem jobItem in jobItems) {
-        DeregisterJobItemEvents(jobItem);
-      }
-    }
-
-    void jobItems_ItemsReplaced(object sender, CollectionItemsChangedEventArgs<IndexedItem<JobItem>> e) {
-      UpdateJobItemEvents(e);
-    }
-
-    private void UpdateJobItemEvents(CollectionItemsChangedEventArgs<IndexedItem<JobItem>> e) {
-      if (e.OldItems != null) {
-        foreach (var item in e.OldItems) {
-          DeregisterJobItemEvents(item.Value);
-        }
-      }
-      if (e.Items != null) {
-        foreach (var item in e.Items) {
-          RegisterJobItemEvents(item.Value);
-        }
-      }
-    }
-
-    private void RegisterJobItemEvents(JobItem jobItem) {
-      jobItem.SnapshotRequestedStateChanged += new EventHandler(JobItem_SnapshotRequestedStateChanged);
-      jobItem.JobStateChanged += new EventHandler(JobItem_JobStateChanged);
-    }
-
-    private void DeregisterJobItemEvents(JobItem jobItem) {
-      jobItem.SnapshotRequestedStateChanged -= new EventHandler(JobItem_SnapshotRequestedStateChanged);
-      jobItem.JobStateChanged -= new EventHandler(JobItem_JobStateChanged);
-    }
-
-    void jobItems_ItemsRemoved(object sender, CollectionItemsChangedEventArgs<IndexedItem<JobItem>> e) {
-      UpdateJobItemEvents(e);
-    }
-
-    void jobItems_ItemsAdded(object sender, CollectionItemsChangedEventArgs<IndexedItem<JobItem>> e) {
-      UpdateJobItemEvents(e);
-    }
-
-    void jobItems_CollectionReset(object sender, CollectionItemsChangedEventArgs<IndexedItem<JobItem>> e) {
-      foreach (var item in e.OldItems) {
-        item.Value.JobStateChanged -= new EventHandler(JobItem_JobStateChanged);
-        item.Value.SnapshotRequestedStateChanged -= new EventHandler(JobItem_SnapshotRequestedStateChanged);
-      }
+    void HiveExperiment_RootJobChanged(object sender, EventArgs e) {
+      this.Experiment = (Optimization.Experiment)((ExperimentJob)rootJobItem.Job).Optimizer;
+    }
+
+    void rootJobItem_FinalResultAvailable(object sender, EventArgs e) {
+      this.Experiment = (Optimization.Experiment)((ExperimentJob)rootJobItem.Job).Optimizer;
     }
     #endregion
-
-    #region Helper Functions
-    private IClientFacade CreateClientFacade() {
-      IClientFacade clientFacade = null;
-      do {
-        try {
-          //clientFacade = ServiceLocator.CreateClientFacade(string.Format("http://{0}:{1}/{2}", Settings.Default.HiveServerIp, Settings.Default.HiveServerPort, WcfSettings.ClientServiceName));
-          clientFacade = ServiceLocator.CreateClientFacade(Settings.Default.HiveServerIp);
-
-        }
-        catch (EndpointNotFoundException exception) {
-          LogMessage("Could not connect to Server: " + exception.Message + ". Will try again in " + (resultPollingIntervalMs / 1000) + " sec.");
-          Thread.Sleep(resultPollingIntervalMs);
-        }
-      } while (clientFacade == null && this.ExecutionState != Core.ExecutionState.Stopped);
-      return clientFacade;
-    }
-
-    private IClientFacade CreateStreamedClientFacade() {
-      IClientFacade clientFacade = null;
-      do {
-        try {
-          //clientFacade = ServiceLocator.CreateStreamedClientFacade(string.Format("http://{0}:{1}/{2}", Settings.Default.HiveServerIp, Settings.Default.HiveServerPort, WcfSettings.ClientStreamedServiceName));
-          clientFacade = ServiceLocator.CreateStreamedClientFacade(Settings.Default.HiveServerIp);
-        }
-        catch (EndpointNotFoundException exception) {
-          LogMessage("Could not connect to Server: " + exception.Message + ". Will try again in " + (resultPollingIntervalMs / 1000) + " sec.");
-          Thread.Sleep(resultPollingIntervalMs);
-        }
-      } while (clientFacade == null && this.ExecutionState != Core.ExecutionState.Stopped);
-      return clientFacade;
-    }
-
-    private void AddRange(IDictionary<IOptimizer, IOptimizer> optimizers, IDictionary<IOptimizer, IOptimizer> childs) {
-      foreach (KeyValuePair<IOptimizer, IOptimizer> kvp in childs) {
-        optimizers.Add(kvp);
-      }
-    }
-
-    #endregion
-
+    
     #region Logging
     private void LogMessage(string message) {
@@ -951,13 +705,32 @@
       lock (locker) {
         log.LogMessage(message);
+        Logger.Debug(message);
       }
     }
 
     private void LogMessage(Guid jobId, string message) {
-      GetJobItemById(jobId).LogMessage(message);
+      //GetJobItemById(jobId).LogMessage(message);
       LogMessage(message + " (jobId: " + jobId + ")");
     }
 
     #endregion
+
+    /// <summary>
+    /// Downloads the root job from hive and sets the experiment, rootJob and rootJobItem
+    /// </summary>
+    public void LoadExperimentFromHive() {
+      using (Disposable<IClientFacade> service = ServiceLocator.Instance.StreamedClientFacadePool.GetService()) {
+        ResponseObject<SerializedJob> response = service.Obj.GetLastSerializedResult(RootJobItem.JobDto.Id);
+        IJob job = XmlParser.Deserialize<IJob>(new MemoryStream(response.Obj.SerializedJobData));
+        RootJob = job;
+        RootJobItem.JobDto = response.Obj.JobInfo;
+        this.Experiment = (Optimization.Experiment)((OptimizerJob)job).Optimizer;
+        if (rootJobItem.JobDto.State == JobState.Finished) {
+          // set execution time and finish up
+        } else if (rootJobItem.JobDto.State != JobState.Aborted && rootJobItem.JobDto.State != JobState.Failed) {
+          this.ExecutionState = Core.ExecutionState.Started;
+        }
+      }
+    }
   }
 }
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/HiveExperimentList.cs
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/HiveExperimentList.cs	(revision 4368)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/HiveExperimentList.cs	(revision 4368)
@@ -0,0 +1,27 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Hive.Contracts.BusinessObjects;
+using HeuristicLab.Hive.Contracts.Interfaces;
+using HeuristicLab.Hive.Experiment.Properties;
+using System.ServiceModel;
+using System.Threading;
+using HeuristicLab.Hive.Contracts.ResponseObjects;
+
+namespace HeuristicLab.Hive.Experiment {
+  [Item("HiveExperiment List", "Represents a list of hive experiments.")]
+  [StorableClass]
+  public class HiveExperimentList : ItemList<HiveExperiment> {
+    public HiveExperimentList() : base() { }
+    public HiveExperimentList(int capacity) : base(capacity) { }
+    public HiveExperimentList(IEnumerable<HiveExperiment> collection) : base(collection) { }
+
+    public override Common.IDeepCloneable Clone(Common.Cloner cloner) {
+      HiveExperimentList clone = (HiveExperimentList)base.Clone(cloner);
+      return clone;
+    }
+  }
+}
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/JobItem.cs
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/JobItem.cs	(revision 4343)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/JobItem.cs	(revision 4368)
@@ -12,4 +12,10 @@
 using HeuristicLab.Optimization;
 using HeuristicLab.Hive.Contracts.ResponseObjects;
+using HeuristicLab.Hive.JobBase;
+using System.IO;
+using HeuristicLab.Persistence.Default.Xml;
+using HeuristicLab.PluginInfrastructure;
+using System.Reflection;
+using HeuristicLab.Hive.Experiment.Jobs;
 
 namespace HeuristicLab.Hive.Experiment {
@@ -22,9 +28,9 @@
     public override Image ItemImage {
       get {
-        if (State == JobState.Offline) return HeuristicLab.Common.Resources.VS2008ImageLibrary.ExecutablePrepared;
-        else if (State == JobState.Calculating) return HeuristicLab.Common.Resources.VS2008ImageLibrary.ExecutableStarted;
-        else if (State == JobState.Aborted) return HeuristicLab.Common.Resources.VS2008ImageLibrary.ExecutableStopped;
-        else if (State == JobState.Failed) return HeuristicLab.Common.Resources.VS2008ImageLibrary.Error;
-        else if (State == JobState.Finished) return HeuristicLab.Common.Resources.VS2008ImageLibrary.ExecutableStopped;
+        if (jobDto.State == JobState.Offline) return HeuristicLab.Common.Resources.VS2008ImageLibrary.ExecutablePrepared;
+        else if (jobDto.State == JobState.Calculating) return HeuristicLab.Common.Resources.VS2008ImageLibrary.ExecutableStarted;
+        else if (jobDto.State == JobState.Aborted) return HeuristicLab.Common.Resources.VS2008ImageLibrary.ExecutableStopped;
+        else if (jobDto.State == JobState.Failed) return HeuristicLab.Common.Resources.VS2008ImageLibrary.Error;
+        else if (jobDto.State == JobState.Finished) return HeuristicLab.Common.Resources.VS2008ImageLibrary.ExecutableStopped;
         else return HeuristicLab.Common.Resources.VS2008ImageLibrary.Event;
       }
@@ -33,7 +39,4 @@
     [Storable]
     private JobDto jobDto;
-    /// <summary>
-    /// Some static information about the job. Don't use State-Information out of there
-    /// </summary>
     public JobDto JobDto {
       get { return jobDto; }
@@ -49,89 +52,47 @@
 
     [Storable]
-    private JobResult jobResult;
-    public JobResult JobResult {
-      private get { return jobResult; }
+    private IJob job;
+    public IJob Job {
+      get { return job; }
       set {
-        if (jobResult != value) {
-          jobResult = value;
-          OnJobStateChanged();
-          OnToStringChanged();
-          OnItemImageChanged();
-        }
-      }
-    }
-
-    public JobState State {
-      get { return jobResult != null ? JobResult.State : JobDto.State; }
-    }
-
-    public double? Percentage {
-      get { return jobResult != null ? JobResult.Percentage : JobDto.Percentage; }
-    }
-
-    public string Exception {
-      get { return jobResult != null ? JobResult.Exception : JobDto.Exception; }
-    }
-
-    public DateTime? DateCalculated {
-      get { return jobResult != null ? JobResult.DateCalculated : JobDto.DateCalculated; }
-    }
-
-    public DateTime? DateFinished {
-      get { return jobResult != null ? JobResult.DateFinished : JobDto.DateFinished; }
-    }
-    
-    [Storable]
-    private ResponseObject<SerializedJob> latestSnapshot;
-    public ResponseObject<SerializedJob> LatestSnapshot {
-      get { return latestSnapshot; }
+        if (job != value) {
+          job = value;
+          IsFinalResultAvailable = job.ExecutionState == ExecutionState.Stopped;
+          OnJobChanged();
+        }
+      }
+    }
+
+    [Storable]
+    private ICollection<JobItem> childJobItems;
+    public IEnumerable<JobItem> ChildJobItems {
+      get { return childJobItems; }
+    }
+
+    [Storable]
+    private bool isFinalResultAvailable;
+    public bool IsFinalResultAvailable {
+      get { return isFinalResultAvailable; }
       set {
-        if (latestSnapshot != value) {
-          latestSnapshot = value;
-          if (value != null) {
-            latestSnapshotTime = DateTime.Now;
-          }
-          SnapshotRequestedState = Experiment.SnapshotRequestedState.Idle;
-          OnLatestSnapshotChanged();
-        }
-      }
-    }
-
-    [Storable]
-    private DateTime latestSnapshotTime;
-    public DateTime LatestSnapshotTime {
-      get { return latestSnapshotTime; }
-    }
-
-    [Storable]
-    private ILog log;
-    public ILog Log {
-      get { return log; }
-    }
-
-    [Storable]
-    private IOptimizer optimizer;
-    public IOptimizer Optimizer {
-      get { return optimizer; }
-      set { this.optimizer = value; }
-    }
-
-    [Storable]
-    private SnapshotRequestedState snapshotRequestedState;
-    public SnapshotRequestedState SnapshotRequestedState {
-      get { return snapshotRequestedState; }
-      private set {
-        this.snapshotRequestedState = value;
-        OnSnapshotRequestedStateChanged();
-      }
-    }
-
+        if (isFinalResultAvailable != value) {
+          isFinalResultAvailable = value;
+          if (isFinalResultAvailable)
+            OnFinalResultAvailable();
+        }
+      }
+    }
+   
     public JobItem() {
-      log = new Log();
+      childJobItems = new List<JobItem>();
+    }
+
+    public JobItem(JobResult jobResult) : this() {
+      this.jobDto = new JobDto();
+      UpdateJob(jobResult);
     }
 
     public override string ToString() {
       if (jobDto != null) {
-        return optimizer.Name;
+        return job.Name;
       } else {
         return base.ToString();
@@ -139,11 +100,66 @@
     }
 
-    public event EventHandler LatestSnapshotChanged;
-    private void OnLatestSnapshotChanged() {
-      LogMessage("LatestSnapshotChanged");
-      EventHandler handler = LatestSnapshotChanged;
-      if (handler != null) handler(this, EventArgs.Empty);
-    }
-
+    public void UpdateJob(JobResult jobResult) {
+      if (jobResult != null) {
+        jobDto.Id = jobResult.Id;
+        jobDto.DateCreated = jobResult.DateCreated;
+        jobDto.DateCalculated = jobResult.DateCalculated;
+        jobDto.DateFinished = jobResult.DateFinished;
+        jobDto.Exception = jobResult.Exception;
+        jobDto.Id = jobResult.Id;
+        jobDto.Percentage = jobResult.Percentage;
+        jobDto.State = jobResult.State;
+        // what about parentJob
+        OnJobStateChanged();
+        OnToStringChanged();
+        OnItemImageChanged();
+      }
+    }
+
+    public void AddChildJob(JobItem child) {
+      this.childJobItems.Add(child);
+      OnChildJobAdded();
+    }
+
+    //public IEnumerable<JobItem> GetChildJobItems() {
+    //  if (childJobItems == null)
+    //    childJobItems = CreateChildJobItems();
+    //  return childJobItems;
+    //}
+
+    //protected IEnumerable<JobItem> CreateChildJobItems() {
+    //  return (from j in Job.ChildJobs
+    //          select new JobItem() {
+    //            Job = j,
+    //            JobDto = new JobDto() {
+    //              State = JobState.Offline
+    //            }
+    //          }).ToList();
+    //}
+
+    public SerializedJob ToSerializedJob() {
+      MemoryStream memStream = new MemoryStream();
+      XmlGenerator.Serialize(job, memStream);
+      byte[] jobByteArray = memStream.ToArray();
+      memStream.Dispose();
+
+      UpdateRequiredPlugins();
+
+      this.JobDto.CoresNeeded = job.CoresNeeded;
+      this.JobDto.MemoryNeeded = job.MemoryNeeded;
+
+      SerializedJob serializedJob = new SerializedJob() {
+        JobInfo = jobDto,
+        SerializedJobData = jobByteArray
+      };
+
+      return serializedJob;
+    }
+
+    private void UpdateRequiredPlugins() {
+      // find out which which plugins are needed for the given object
+      this.JobDto.PluginsNeeded = HivePluginInfoDto.FindPluginsNeeded(job.GetType());
+    }
+   
     public event EventHandler JobDtoChanged;
     private void OnJobDtoChanged() {
@@ -155,6 +171,24 @@
     public event EventHandler JobStateChanged;
     private void OnJobStateChanged() {
-      LogMessage("JobStateChanged (State: " + this.State + ", Percentage: " + this.Percentage + ")");
+      LogMessage("JobStateChanged (State: " + this.JobDto.State + ", Percentage: " + this.JobDto.Percentage + ")");
       EventHandler handler = JobStateChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+    
+    public event EventHandler ChildJobAdded;
+    private void OnChildJobAdded() {
+      var handler = ChildJobAdded;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+    
+    public event EventHandler JobChanged;
+    private void OnJobChanged() {
+      var handler = JobChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+
+    public event EventHandler FinalResultAvailable;
+    private void OnFinalResultAvailable() {
+      var handler = FinalResultAvailable;
       if (handler != null) handler(this, EventArgs.Empty);
     }
@@ -162,5 +196,7 @@
     public void LogMessage(string message) {
       lock (locker) {
-        log.LogMessage(message);
+        if (job != null) {
+          job.Log.LogMessage(message);
+        }
       }
     }
@@ -169,25 +205,26 @@
       LogMessage("I am beeing cloned");
       JobItem clone = (JobItem)base.Clone(cloner);
-      clone.latestSnapshotTime = this.latestSnapshotTime;
       clone.jobDto = (JobDto)cloner.Clone(this.jobDto);
-      clone.latestSnapshot = (ResponseObject<SerializedJob>)cloner.Clone(this.latestSnapshot);
-      clone.log = (ILog)cloner.Clone(this.log);
-      clone.optimizer = (IOptimizer)cloner.Clone(this.optimizer);
-      clone.jobResult = (JobResult)cloner.Clone(this.jobResult);
+      clone.job = (IJob)cloner.Clone(this.job);
       return clone;
     }
 
-
-    public event EventHandler SnapshotRequestedStateChanged;
-    private void OnSnapshotRequestedStateChanged() {
-      EventHandler handler = SnapshotRequestedStateChanged;
-      if (handler != null) handler(this, EventArgs.Empty);
-    }
-
-    public void RequestSnapshot() {
-      this.SnapshotRequestedState = Experiment.SnapshotRequestedState.Requested;
-    }
-
-
+    public void UpdateFinalResults(IJob j) {
+      if (this.Job is OptimizerJob && j is OptimizerJob) {
+        ((OptimizerJob)this.Job).Optimizer.Runs.AddRange(((OptimizerJob)j).Optimizer.Runs);
+        IsFinalResultAvailable = true; //job.ExecutionState == ExecutionState.Stopped; //??
+      } else {
+        throw new NotSupportedException();
+      }
+    }
+
+    internal bool ReplaceChildJob(IJob job) {
+      var matches = this.childJobItems.Where(child => child.Job.InternalId == job.InternalId);
+      if (matches.Count() > 0) {
+        matches.First().job = job;
+        return true;
+      }
+      return false;
+    }
   }
 }
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/Jobs/BachRunJob.cs
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/Jobs/BachRunJob.cs	(revision 4368)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment/3.3/Jobs/BachRunJob.cs	(revision 4368)
@@ -0,0 +1,26 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Hive.JobBase;
+using HeuristicLab.Optimization;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Hive.Experiment.Jobs {
+  [StorableClass]
+  public class BatchRunJob : OptimizerJob {
+    public BatchRunJob() {
+    }
+
+    public BatchRunJob(IOptimizer optimizer) : base(optimizer) { }
+
+    public override void Start() {
+      base.Start();
+    }
+
+    public override bool IsParallelizable {
+      get { return true; }
+    }
+  }
+}
